const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const place_categories = sequelize.define(
    'place_categories',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

slug: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

color_hex: {
        type: DataTypes.TEXT,
      
      

      },

icon_name: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  place_categories.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






    db.place_categories.hasMany(db.places, {
      as: 'places_category',
      foreignKey: {
          name: 'categoryId',
      },
      constraints: false,
    });







    db.place_categories.hasMany(db.search_logs, {
      as: 'search_logs_category',
      foreignKey: {
          name: 'categoryId',
      },
      constraints: false,
    });




//end loop






    db.place_categories.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.place_categories.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return place_categories;
};


